| OpenCV 4.3.0 Open Source Computer Vision

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
cv::Algorithm Class Reference
Core functionality » Basic structures

This is a base class for all more or less complex algorithms in OpenCV. More...

`#include <opencv2/core.hpp>`

Inheritance diagram for cv::Algorithm:

## Public Member Functions
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Static Public Member Functions
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...

## Protected Member Functions
void | writeFormat (FileStorage &fs) const

## Detailed Description

This is a base class for all more or less complex algorithms in OpenCV.

especially for classes of algorithms, for which there can be multiple implementations. The examples are stereo correspondence (for which there are algorithms like block matching, semi-global block matching, graph-cut etc.), background subtraction (which can be done using mixture-of-gaussians models, codebook-based algorithm etc.), optical flow (block matching, Lucas-Kanade, Horn-Schunck etc.).

Here is example of SimpleBlobDetector use in your application via Algorithm interface:

Ptr<Feature2D> sbd = SimpleBlobDetector::create();
FileStorage fs_read("SimpleBlobDetector_params.xml", FileStorage::READ);
if (fs_read.isOpened()) // if we have file with parameters, read them
{
sbd->read(fs_read.root());
fs_read.release();
}
else // else modify the parameters and store them; user can later edit the file to use different parameters
{
fs_read.release();
FileStorage fs_write("SimpleBlobDetector_params.xml", FileStorage::WRITE);
sbd->write(fs_write);
fs_write.release();
}
Mat result, image = imread("../data/detect_blob.png", IMREAD_COLOR);
vector<KeyPoint> keypoints;
sbd->detect(image, keypoints, Mat());
drawKeypoints(image, keypoints, result);
for (vector<KeyPoint>::iterator k = keypoints.begin(); k != keypoints.end(); ++k)
circle(result, k->pt, (int)k->size, Scalar(0, 0, 255), 2);
imshow("result", result);
waitKey(0);

## Constructor & Destructor Documentation

## ◆ Algorithm()

cv::Algorithm::Algorithm | ( |  | ) |

## ◆ ~Algorithm()

virtual cv::Algorithm::~Algorithm | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ clear()

virtual void cv::Algorithm::clear | ( |  | ) |
| inline virtual

Python:
| None | = | cv.Algorithm.clear( |  | )

Clears the algorithm state.

Reimplemented in cv::FlannBasedMatcher, cv::line_descriptor::BinaryDescriptorMatcher, cv::DescriptorMatcher, cv::cuda::DescriptorMatcher, cv::quality::QualityPSNR, cv::quality::QualityBase, cv::quality::QualityGMSD, cv::quality::QualitySSIM, and cv::quality::QualityMSE.

## ◆ empty()

virtual bool cv::Algorithm::empty | ( |  | ) | const
| inline virtual

Python:
| retval | = | cv.Algorithm.empty( |  | )

Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read.

Reimplemented in cv::DescriptorMatcher, cv::face::FaceRecognizer, cv::ml::StatModel, cv::Feature2D, cv::BaseCascadeClassifier, cv::cuda::DescriptorMatcher, cv::quality::QualityPSNR, cv::quality::QualityBase, cv::face::BasicFaceRecognizer, cv::quality::QualityGMSD, cv::quality::QualitySSIM, and cv::quality::QualityMSE.

## ◆ getDefaultName()

virtual String cv::Algorithm::getDefaultName | ( |  | ) | const
| virtual

Python:
| retval | = | cv.Algorithm.getDefaultName( |  | )

Returns the algorithm string identifier. This string is used as top level xml/yml node tag when the object is saved to a file or string.

Reimplemented in cv::AKAZE, cv::KAZE, cv::SimpleBlobDetector, cv::GFTTDetector, cv::AgastFeatureDetector, cv::FastFeatureDetector, cv::MSER, cv::ORB, cv::BRISK, and cv::Feature2D.

## ◆ load()

template<typename _Tp >

static Ptr<_Tp> cv::Algorithm::load | ( | const String & | filename,
|  | const String & | objname = `String()`
| ) |  |
| inline static

Loads algorithm from the file.

Parameters

  filename | Name of the file to read.
  objname | The optional name of the node to read (if empty, the first top-level node will be used)

This is static template method of Algorithm. It's usage is following (in the case of SVM):

Ptr<SVM> svm = Algorithm::load<SVM>("my_svm_model.xml");

In order to make this method work, the derived class must overwrite Algorithm::read(const FileNode& fn).

## ◆ loadFromString()

template<typename _Tp >

static Ptr<_Tp> cv::Algorithm::loadFromString | ( | const String & | strModel,
|  | const String & | objname = `String()`
| ) |  |
| inline static

Loads algorithm from a String.

Parameters

  strModel | The string variable containing the model you want to load.
  objname | The optional name of the node to read (if empty, the first top-level node will be used)

This is static template method of Algorithm. It's usage is following (in the case of SVM):

Ptr<SVM> svm = Algorithm::loadFromString<SVM>(myStringModel);

## ◆ read() [1/2]

virtual void cv::Algorithm::read | ( | const FileNode & | fn | ) |
| inline virtual

Python:
| None | = | cv.Algorithm.read( | fn | )

Reads algorithm parameters from a file storage.

Reimplemented in cv::FlannBasedMatcher, cv::DescriptorMatcher, cv::Tracker, cv::face::FaceRecognizer, cv::optflow::GPCForest< T >, cv::line_descriptor::BinaryDescriptor, cv::Feature2D, cv::optflow::GPCTree, cv::saliency::StaticSaliencySpectralResidual, and cv::face::BasicFaceRecognizer.

## ◆ read() [2/2]

template<typename _Tp >

static Ptr<_Tp> cv::Algorithm::read | ( | const FileNode & | fn | ) |
| inline static

Python:
| None | = | cv.Algorithm.read( | fn | )

Reads algorithm from the file node.

This is static template method of Algorithm. It's usage is following (in the case of SVM):

cv::FileStorage fsRead("example.xml", FileStorage::READ);
Ptr<SVM> svm = Algorithm::read<SVM>(fsRead.root());

In order to make this method work, the derived class must overwrite Algorithm::read(const FileNode& fn) and also have static create() method without parameters (or with all the optional parameters)

## ◆ save()

virtual void cv::Algorithm::save | ( | const String & | filename | ) | const
| virtual

Python:
| None | = | cv.Algorithm.save( | filename | )

Saves the algorithm to a file. In order to make this method work, the derived class must implement Algorithm::write(FileStorage& fs).

## ◆ write() [1/2]

virtual void cv::Algorithm::write | ( | FileStorage & | fs | ) | const
| inline virtual

Python:
| None | = | cv.Algorithm.write( | fs[, name] | )

Stores algorithm parameters in a file storage.

Reimplemented in cv::FlannBasedMatcher, cv::DescriptorMatcher, cv::Tracker, cv::face::FaceRecognizer, cv::optflow::GPCForest< T >, cv::bioinspired::Retina, cv::line_descriptor::BinaryDescriptor, cv::Feature2D, cv::optflow::GPCTree, cv::bioinspired::TransientAreasSegmentationModule, cv::saliency::StaticSaliencySpectralResidual, and cv::face::BasicFaceRecognizer.

## ◆ write() [2/2]

void cv::Algorithm::write | ( | const Ptr< FileStorage > & | fs,
|  | const String & | name = `String()`
| ) |  | const

Python:
| None | = | cv.Algorithm.write( | fs[, name] | )

simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ writeFormat()

void cv::Algorithm::writeFormat | ( | FileStorage & | fs | ) | const
| protected

The documentation for this class was generated from the following file:

- opencv2/core.hpp